# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .graph_data_type import GraphDataType
from .role_type import RoleType


class Episode(pydantic_v1.BaseModel):
    content: str
    created_at: str
    processed: typing.Optional[bool] = None
    role: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Optional role, will only be present if the episode was created using memory.add API
    """

    role_type: typing.Optional[RoleType] = pydantic_v1.Field(default=None)
    """
    Optional role_type, will only be present if the episode was created using memory.add API
    """

    session_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Optional session ID. Will be present only if the episode corresponds to the messages added using memory.add API
    """

    source: typing.Optional[GraphDataType] = None
    source_description: typing.Optional[str] = None
    uuid_: str = pydantic_v1.Field(alias="uuid")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
